/*
 * @(#)%Name% %Version% %Time%
 * 
 * Copyright (c) 1997 Rutgers University
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that (i) the above copyright notice and this permission notice
 * appear in all copies of the software and related documentation. (ii) 
 * the name of Rutgers University may not be used in any advertising
 * or publicity relating to the software without the specific, prior
 * written permission of Rutgers University.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL RUTGERS UNIVERSITY BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
 * THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE
 * OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * CopyrightVersion %Version%
 * @author		%Author%
 * @version		%Version%, %Time%
 * @since		ACT %Version%
 *
 */

package EDU.rutgers.CORBA.GIOP.actions;

import EDU.rutgers.act.protocol.Message;

import EDU.rutgers.act.protocol.FSMAction;
import EDU.rutgers.act.protocol.FSMDataFactory;
import EDU.rutgers.act.protocol.FSMData;
import EDU.rutgers.act.protocol.FSMDataFactory;

public class GIOPClientDataFactory implements FSMDataFactory
{
    public FSMData createFSMData() {
        // create the START row
        FSMAction err = new FSMAction() {
	        public int run(Message previous, Message current, Message[] next) {
                next[0] = null;
	            return FSMAction.EXIT;
	        }
	    };
        FSMAction start_request = new FSMAction() {
	        public int run(Message previous, Message current, Message[] next) {
                next[0] = current;
	            return GIOPAction.REQUEST;
	        }
	    };              
        FSMAction start_cancelRequest = new FSMAction() {
	        public int run(Message previous, Message current, Message[] next) {
                next[0] = current;
                return FSMAction.EXIT;
	        }
	    };
        FSMAction start_locateRequest = new FSMAction() {
	        public int run(Message previous, Message current, Message[] next) {
                next[0] = current;
                return GIOPAction.LOCATE;
	        }
	    };
        FSMAction[] startActions = {start_request, err, start_cancelRequest, start_locateRequest, err, err, };

        // create the REQUEST row
        FSMAction request_request = new GIOPClientRequestAction();
        FSMAction[] requestActions = {err, request_request, err, err, err, request_request,};

        // create the LOCATE row
        FSMAction locate_locate = new GIOPClientLocateAction();
        FSMAction[] locateActions = {err, err, err, err, locate_locate, locate_locate, };
  
        // compose the table
        FSMAction[][] fsmTable = {
		startActions,    		// START
		{err, err, err, err, err, err}, // EXIT
		{err, err, err, err, err, err}, // ERROR
		requestActions,  		// REQUEST
		locateActions,}; 		// LOCATE

        boolean[] isFinal = {false, true, true, false, false};

        FSMData fsmData = new FSMData(fsmTable, isFinal, FSMAction.START);
        return fsmData;
    }
}
