// for emacs only: -*- C++ -*-

// last update: 08/31/1997

package EDU.rutgers.CORBA.idl.ir;

public class DoubleCell extends FloatingPtTypeCell
{
  public DoubleCell()
    {
      type_ = T_DOUBLE;
    }

  public void generate(int attr)
    {
      String type = ((attr == ParamDclCell.IN) ? "double" : "DoubleHolder");
      Generator.interfaceWriter_.print(type);
      Generator.staticStubWriter_.print(type);
      Generator.staticSkelWriter_.print(type);
    }

  public String toString()
    {
      return "double";
    }

  public String toString(int attr)
    {
      if(attr == ParamDclCell.IN)
	return "double";
      return "DoubleHolder";
    }

  public String initialValue()
    {
      return "0";
    }

  void genStubIn(int indent, String str)
    {
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	"out.writeDouble(" +
        str +
	");"
				);
    }

  void genStubOut(int indent, String str)
    {
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	str +
	" = in.readDouble();"
				);
    }

  void genSkelIn(int indent, String str)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	str +
        " = in.readDouble();");
    }

  void genSkelOut(int indent, String str)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	"out.writeDouble(" +
        str +
	");"
					  );
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("double");
    }
}
