// for emacs only: -*- C++ -*-

// last update: 08/31/1997

package EDU.rutgers.CORBA.idl.ir;

public class InterfaceHeaderCell extends Cell
{
  // data members

  public Cell inheritance_;
  public String id_;

  public InterfaceHeaderCell(String identifier, 
			     Cell inheritance)
    {
      type_ = T_INTERFACE_HEADER;
      inheritance_ = inheritance;
      id_ = identifier;
    }

  public void generate(int indent) throws java.io.IOException
    {
      // first define the type <interface name>
      String key = Generator.packTrack_.toString();
      key = (key == null) ? id_ : key + "." + id_;
      ParamTypeSpecCell realType  = new InterfaceTypeCell(key);
      // System.err.println("Adding type " + key);
      Generator.symTab_.put(key, realType);

      //
      // interface
      //
      Generator.interfaceWriter_ = 
	new java.io.PrintWriter(
	  Generator.fileFactory_.create(id_ + ".java"));

      Generator.interfaceWriter_.println(
	"package " + Generator.packTrack_.toString() +
         ";\n\n");
      Generator.interfaceWriter_.println(
	"import ORG.omg.CORBA.*;\n");
      Generator.interfaceWriter_.println(
		    "public interface " + id_ + " extends");

      Generator.interfaceWriter_.print("        ORG.omg.CORBA.Object");
//      if(inheritance_ != null) inheritance_.generate(8);
      Generator.interfaceWriter_.println();

      //
      // helper
      //
      java.io.PrintWriter helper = 
	new java.io.PrintWriter(
	  Generator.fileFactory_.create(id_ + "Helper.java"));
      helper.println(
	"package " + Generator.packTrack_.toString() +
         ";\n\n");
      helper.println("public class " + id_ + "Helper");
      helper.println("{");
      helper.println("  public static " + id_ + 
		     " narrow(ORG.omg.CORBA.Object reference)");
      helper.println("    {");
      helper.println("      return (" + id_ + ") new " + 
		     id_ + "Stub(");
      helper.println("          ((EDU.rutgers.CORBA.clntsrv.PortableServer.ObjectReference)reference).getIOR());");
      helper.println("    }");
      helper.println("}");
      helper.close();

      //
      // holder
      //
      java.io.PrintWriter holder =
	new java.io.PrintWriter(
	  Generator.fileFactory_.create(id_ + "Holder.java"));
      holder.println(
	"package " + Generator.packTrack_.toString() +
         ";\n\n");
      holder.println("final public class " + id_ + "Holder");
      holder.println("{");
      holder.println("  public " + id_ + 
		     " value;");
      holder.println("  public " + id_ + 
		     "Holder() {}");
      holder.println("  public " + id_ + 
		     "Holder(" + id_ + " initial) {");
      holder.println("    value = initial;");
      holder.println("  }");
      holder.println("}");
      holder.close();

      //
      // static stub
      //
      Generator.staticStubWriter_ = 
	new java.io.PrintWriter(
	  Generator.fileFactory_.create(id_ + "Stub.java"));

      Generator.staticStubWriter_.println(
	"package " + Generator.packTrack_.toString() +
         ";\n\n");
      Generator.staticStubWriter_.println(
	"import ORG.omg.CORBA.*;");
      Generator.staticStubWriter_.println(
	"import EDU.rutgers.CORBA.IOP.IOR;");
      Generator.staticStubWriter_.println(
	"import EDU.rutgers.CORBA.clntsrv.PortableServer.ObjectReference;");
      Generator.staticStubWriter_.println(
	"import EDU.rutgers.act.presentation.TypeWriter;");
      Generator.staticStubWriter_.println(
	"import EDU.rutgers.act.presentation.TypeReader;");
      Generator.staticStubWriter_.println("");
      
      Generator.staticStubWriter_.println(
        "public class " + id_ + "Stub");
      Generator.staticStubWriter_.println(
        "  extends EDU.rutgers.CORBA.clntsrv.PortableServer.ObjectReference");
      Generator.staticStubWriter_.println("  implements " + id_);
      Generator.staticStubWriter_.println("{");
      Generator.staticStubWriter_.println(
        "  public " + id_ +  "Stub" + "(IOR ior)");
      Generator.staticStubWriter_.println("    {");
      Generator.staticStubWriter_.println("      super(ior);");
      Generator.staticStubWriter_.println("    }");
      Generator.staticStubWriter_.println("");
      
      //
      // static skeleton
      //
      Generator.staticSkelWriter_ = 
	new java.io.PrintWriter(
	  Generator.fileFactory_.create("_" + id_ + "ImplBase.java"));
      Generator.staticSkelWriter_.println(
	"package " + Generator.packTrack_.toString() +
         ";\n\n");
      Generator.staticSkelWriter_.println(
	"import ORG.omg.CORBA.*;");
      Generator.staticSkelWriter_.println(
	"import EDU.rutgers.CORBA.IOP.IOR;");
      Generator.staticSkelWriter_.println(
	"import EDU.rutgers.CORBA.clntsrv.PortableServer.ObjectReference;");
      Generator.staticSkelWriter_.println(
	"import EDU.rutgers.act.presentation.TypeWriter;");
      Generator.staticSkelWriter_.println(
	"import EDU.rutgers.act.presentation.TypeReader;");
      Generator.staticSkelWriter_.println("");
      
      Generator.staticSkelWriter_.println(
        "public abstract class " + "_" + id_ + "ImplBase");
      Generator.staticSkelWriter_.println(
        "  extends EDU.rutgers.CORBA.clntsrv.PortableServer.Skeleton");
      Generator.staticSkelWriter_.println("  implements " + id_);
      Generator.staticSkelWriter_.println("{");
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("INTERFACE_HEADER:");
 
      printIndent(indent + 2);
      System.out.println("INTERFACE NAME: " + id_);

/*
      if(inheritance_ != null)
	inheritance_.print(indent + 2);
      else
	{
	  printIndent(indent + 2);
	  System.out.println("null");
	}      
*/
    }
}
