// for emacs only: -*- C++ -*-

// last update: 10/19/1997

package EDU.rutgers.CORBA.idl.ir;

public class InterfaceTypeCell extends ParamTypeSpecCell
{
  public String name_; // name of the interface

  public InterfaceTypeCell(String name)
    {
      type_ = T_INTERFACE;
      name_ = name;
    }

  public void generate(int attr)
    {
      String type = toString(attr);
      Generator.interfaceWriter_.print(type);
      Generator.staticStubWriter_.print(type);
      Generator.staticSkelWriter_.print(type);
    }

  public String toString()
    {
      return name_;
    }

  public String toString(int attr)
    {
      return name_ + ((attr == ParamDclCell.IN) ? "": 
                                                             "Holder");
    }

  public String initialValue()
    {
      return "null";
    }

  void genStubIn(int indent, String str)
    {
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
        "((ObjectReference)" + str + ").getIOR().write(out);"
      );
    }

  void genStubOut(int indent, String str)
    {
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println("ior = new IOR();");
      
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println("ior.read(in);");
      
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	str +
	" = " +
	toString() +
        "Helper.narrow((ORG.omg.CORBA.Object) new ObjectReference(ior));"
      );
    }

  void genSkelIn(int indent, String str)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("ior = new IOR();");
      
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("ior.read(in);");
      
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	str +
	" = " +
	toString() +
        "Helper.narrow((ORG.omg.CORBA.Object) new ObjectReference(ior));"
      );
    }

  void genSkelOut(int indent, String str)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
        "((ObjectReference)" + str + ").getIOR().write(out);"
      );
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("INTERFACE: " + name_);
    }
}
