// for emacs only: -*- C++ -*-

// last update: 08/31/1997

package EDU.rutgers.CORBA.idl.ir;

public class OctetCell extends BaseTypeSpecCell
{
  public OctetCell()
    {
      type_ = T_OCTET;
    }

  public void generate(int attr)
    {
      String type = ((attr == ParamDclCell.IN) ? "byte" : "ByteHolder");
      Generator.interfaceWriter_.print(type);
      Generator.staticStubWriter_.print(type);
      Generator.staticSkelWriter_.print(type);
    }

  public String toString()
    {
      return "byte";
    }

  public String toString(int attr)
    {
      if(attr == ParamDclCell.IN)
	return "byte";
      return "ByteHolder";
    }

  public String initialValue()
    {
      return "0";
    }

  void genStubIn(int indent, String str)
    {
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	"out.writeOctet(" +
        str +
	");"
				);
    }

  void genStubOut(int indent, String str)
    {
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	str +
	" = in.readOctet();"
				);
    }

  void genSkelIn(int indent, String str)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	str +
        " = in.readOctet();");
    }

  void genSkelOut(int indent, String str)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	"out.writeOctet(" +
        str +
	");"
					  );
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("octet");
    }
}
