// for emacs only: -*- C++ -*-

// last update: 08/31/1997

package EDU.rutgers.CORBA.idl.ir;

public class OpDclCell extends ExportCell
{
  // data members

  public TypeSpecCell returnType_;   // return type
  public ParameterDclsCell paramList_; // parameter list
  public String id_;                   // operation name
  public boolean oneway_;              // oneway or not

  // constructors

  public OpDclCell(boolean oneway, 
		   TypeSpecCell returnType, 
		   String id, 
		   ParameterDclsCell paramList)
    {
      type_ = T_OP_DECL;
      id_ = id;
      oneway_ = oneway;
      returnType_ = returnType;
      paramList_ = paramList;
    }

  // methods

  public void generate(int indent) throws java.io.IOException
    {
      //
      // interface + Helper + static Stub method header + 
      // static Skeleton method header
      //
      printIndent(indent, Generator.interfaceWriter_);
      printIndent(indent, Generator.staticStubWriter_);
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticStubWriter_.print("public ");
      Generator.staticSkelWriter_.print("public " +
	((id_.compareTo("_is_a") == 0)?"":"abstract "));
      returnType_.generate(ParamDclCell.IN); // "in" like form
      Generator.interfaceWriter_.println(" " + id_ + "(");
      Generator.staticStubWriter_.println(" " + id_ + "(");
      Generator.staticSkelWriter_.println(" " + id_ + "(");
      if(paramList_ != null)
	paramList_.generate(indent + 8);
      printIndent(indent, Generator.interfaceWriter_);
      printIndent(indent, Generator.staticStubWriter_);
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.interfaceWriter_.println(");");
      Generator.staticStubWriter_.println(")");
      Generator.staticSkelWriter_.print(")");
      if(id_.compareTo("_is_a") == 0)
	{
	  // '_is_a' method should be implemented here
	  // for the moment it will return true always
	  Generator.staticSkelWriter_.println();
	  printIndent(indent + 2, Generator.staticSkelWriter_);
	  Generator.staticSkelWriter_.println("{");
	  printIndent(indent + 4, Generator.staticSkelWriter_);
	  Generator.staticSkelWriter_.println("return true;");
	  printIndent(indent + 2, Generator.staticSkelWriter_);
	  Generator.staticSkelWriter_.println("}");
	}
      else
	Generator.staticSkelWriter_.println(";");

      printIndent(indent + 2, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println("{");

      printIndent(indent + 4, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
        "TypeWriter out = getTypeWriter(\"" +
	id_ +
        "\");");

      //
      // Static Stub
      //

      ParamTypeSpecCell retType = null;
      String auxStr = returnType_.toString();
      boolean retValue = (returnType_.type_ != Cell.T_VOID);
      if(retValue)
	{
	  retType = (ParamTypeSpecCell)returnType_;
	}
      

      if(retValue)
	{
	  printIndent(indent + 4, Generator.staticStubWriter_);
	  Generator.staticStubWriter_.println(auxStr +
					      " result = " +
					      retType.initialValue() +
					      ";");
	}
      
      // declare the IOR used to receive object references
      printIndent(indent + 4, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println("IOR ior;");

      // declare arguments
      if(paramList_ != null)
	paramList_.genStubArg(indent + 4, "");

      if(retValue || (paramList_ != null)) // 'try' only if read or write
	{
	  printIndent(indent + 4, Generator.staticStubWriter_);
	  Generator.staticStubWriter_.println("try {");
	}
      

      // write the in and inout arguments to the TypeWriter
      if(paramList_ != null)
	paramList_.genStubIn(indent + 6, "");

      printIndent(indent + 6, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println("TypeReader in = getTypeReader();");

      // read result if it is the case
      if(retValue)
	{
	  retType.genStubOut(indent + 6, "result");
	}

      // read the out and inout arguments from the TypeReader
      if(paramList_ != null)
	paramList_.genStubOut(indent + 6, "");
      
      if(retValue || (paramList_ != null)) // 'try' only if read or write
	{
	  printIndent(indent + 4, Generator.staticStubWriter_);
	  Generator.staticStubWriter_.println("}");
	  printIndent(indent + 4, Generator.staticStubWriter_);
	  Generator.staticStubWriter_.println("catch(java.io.IOException e)");
	  printIndent(indent + 4, Generator.staticStubWriter_);
	  Generator.staticStubWriter_.println("{");
	  printIndent(indent + 4, Generator.staticStubWriter_);
	  Generator.staticStubWriter_.println("  System.out.println(\"Marshaling/unmarshaling error: \" + e);");
	  printIndent(indent + 4, Generator.staticStubWriter_);
	  Generator.staticStubWriter_.println("  System.exit(1);");
	  printIndent(indent + 4, Generator.staticStubWriter_);
	  Generator.staticStubWriter_.println("}");
	  if(retValue)
	    {
	      printIndent(indent + 4, Generator.staticStubWriter_);
	      Generator.staticStubWriter_.println("return result;");
	    }
	  
	}

      printIndent(indent + 2, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println("}\n");

      //
      // Static Skeleton
      //
      Generator.staticSkelWriter_.println();
      Generator.staticSkelWriter_.println(
	"  protected void " +
        id_ +
	"Invoke(TypeReader in, TypeWriter out)");
      Generator.staticSkelWriter_.println("    {");
      

      // declare arguments
      if(paramList_ != null)
	paramList_.genSkelArg(indent + 4, "");

      // declare the IOR used to receive object references
      printIndent(indent + 4, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("IOR ior;");

      // begin the try statement
      Generator.staticSkelWriter_.println(
        "      try"); 
      Generator.staticSkelWriter_.println(
        "	{"); 

      // read the in and inout arguments from the TypeReader
      if(paramList_ != null)
	paramList_.genSkelIn(indent + 8, "");

      // write result if it is the case
      printIndent(indent + 8, Generator.staticSkelWriter_);
      if(retValue)
	{
	  Generator.staticSkelWriter_.print(auxStr + " result = ");
	}
      
      // call the implementation method
      Generator.staticSkelWriter_.println(id_ +
					"(" +
					((paramList_ == null) ? "" :
					paramList_.toString()) +
					");");

      // write result if any
      if(retValue)
	{
	  retType.genSkelOut(indent + 8, "result");
	}

      // write result, the out and inout arguments to the TypeWriter
      if(paramList_ != null)
	paramList_.genSkelOut(indent + 8, "");

      // end the try statement
      Generator.staticSkelWriter_.println("          out.flush();");
      Generator.staticSkelWriter_.println("        }");
      Generator.staticSkelWriter_.println("      catch(java.io.IOException e)");
      Generator.staticSkelWriter_.println("        {");
      Generator.staticSkelWriter_.println("          System.out.println(\"Marshaling/unmarshaling error: \" + e);");
      Generator.staticSkelWriter_.println("          System.exit(1);");
      Generator.staticSkelWriter_.println("        }");
      
      Generator.staticSkelWriter_.println("    }\n");
    }

  void genSkelOps(int indent)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
        "if(operation.compareTo(\"" +
        id_ +
        "\") == 0)");

      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("  {");
      
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("     " +
					  id_ +
					  "Invoke(in, out);");

      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("  }");
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("else");
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("OP_DECL:");

      printIndent(indent + 2);
      System.out.println("ONEWAY: " + oneway_);
      
      printIndent(indent + 2);
      System.out.println("OPERATION NAME: " + id_);

      printIndent(indent + 2);
      System.out.println("OPERATION TYPE:");
      if(returnType_ != null)
	  returnType_.print(indent + 4);
      else
	{
	  printIndent(indent + 4);
	  System.out.println("void");
	}      

      printIndent(indent + 2);
      System.out.println("OPERATION ARGUMENTS:");
      if(paramList_ != null)
	paramList_.print(indent + 4);
      else
	{
	  printIndent(indent + 4);
	  System.out.println("none");
	}      
    }
}
