// for emacs only: -*- C++ -*-

// last update: 08/31/1997

package EDU.rutgers.CORBA.idl.ir;

public class ParamDclCell extends Cell
{
  // constants
  public final static int IN    = 0;
  public final static int OUT   = 1;
  public final static int INOUT = 2;


  // data members

  public int attr_;      // in, out, or inout
  public String id_; // parameter's name
  public ParamTypeSpecCell paramType_; // parameter's type

  public ParamDclCell(int attr, String id, ParamTypeSpecCell paramType)
    {
      type_ = T_PARAM_DCL;
      attr_ = attr;
      id_ = id;
      paramType_ = paramType;
    }

  public void generate(int indent) throws java.io.IOException
    {
      printIndent(indent, Generator.interfaceWriter_);
      printIndent(indent, Generator.staticStubWriter_);
      printIndent(indent, Generator.staticSkelWriter_);
      paramType_.generate(attr_);
      Generator.interfaceWriter_.print(" " + id_);
      Generator.staticStubWriter_.print(" " + id_);
      Generator.staticSkelWriter_.print(" " + id_);
    }

  void genStubArg(int indent, String str)
    {
      if((attr_ == OUT) || (attr_ == INOUT))
	{
	  printIndent(indent, Generator.staticStubWriter_);
	  Generator.staticStubWriter_.println(
		   paramType_.toString() +
		   " " + id_ + "Aux = " +
		   paramType_.initialValue() + ";");
	}
      
    }

  void genStubIn(int indent, String str)
    {
      if(attr_ == IN)
	{
	  paramType_.genStubIn(indent, id_);
	}
      else
	if(attr_ == INOUT)
	{
	  paramType_.genStubIn(indent, id_ + ".value");
	}
    }

  void genStubOut(int indent, String str)
    {
      if((attr_ == OUT) || (attr_ == INOUT))
	{
	  paramType_.genStubOut(indent, id_ + "Aux");
	  printIndent(indent, Generator.staticStubWriter_);
	  Generator.staticStubWriter_.println(
	    id_ + ".value = " + id_ + "Aux;");
	}
    }

  void genSkelArg(int indent, String str)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
        paramType_.toString(attr_) +
        " " + id_ + " = " +
        ((attr_ == IN) ? "" : "new " +  paramType_.toString(attr_) + "(") +
        paramType_.initialValue() + 
        ((attr_ == IN) ? "" : ")") +
        ";");
    }

  void genSkelIn(int indent, String str)
    {
      if(attr_ == IN)
	{
	  paramType_.genSkelIn(indent, id_);
	}
      else
	if(attr_ == INOUT)
	  {
	    paramType_.genSkelIn(indent, id_ + ".value");
	  }
    }

  void genSkelOut(int indent, String str)
    {
      if((attr_ == OUT) || (attr_ == INOUT))
	{
	  paramType_.genSkelOut(indent, id_ + ".value");
	}
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("PARAM_DCL:");
 
      printIndent(indent + 2);
      System.out.println("ATTR: " + (attr_ == IN ? "IN" : attr_ == OUT ? "OUT" : "INOUT"));
 
      printIndent(indent + 2);
      System.out.println("PARAM NAME: " + id_);

      if(paramType_ != null)
	paramType_.print(indent + 2);
      else
	{
	  printIndent(indent + 2);
	  System.out.println("null");
	}      
    }
}
