// for emacs only: -*- C++ -*-

// last update: 08/31/1997

package EDU.rutgers.CORBA.idl.ir;

public class SequenceCell extends ParamTypeSpecCell
{
  // data members
  public ParamTypeSpecCell base_; // the base type
  public int size_;               // the size (-1 if no size specified)
  public String id_;              // the name of the sequence (typedef)

  public SequenceCell(ParamTypeSpecCell base, int size)
    {
      type_ = T_SEQUENCE;
      base_ = base;
      size_ = size;
      id_ = null;
    }

  public void generate(int attr)
    {
      if(attr == ParamDclCell.IN)
	{
	  base_.generate(attr);
	  Generator.interfaceWriter_.print("[]");
	  Generator.staticStubWriter_.print("[]");
	  Generator.staticSkelWriter_.print("[]");
	}
      else
	{
	  final String type = id_ + "Holder";
	  Generator.interfaceWriter_.print(type);
	  Generator.staticStubWriter_.print(type);
	  Generator.staticSkelWriter_.print(type);
	}
    }

  public String toString()
    {
      return toString(ParamDclCell.IN);
    }

  public String toString(int attr)
    {
      if(attr == ParamDclCell.IN)
	return base_.toString() + "[]";
      return id_ + "Holder";
    }

  public String initialValue()
    {
      return "null";
    }

  void genStubIn(int indent, String str)
    {
      if(id_ == null)
	id_ = "Seq" + Generator.index_++;
      String index = id_ + "Ind";

      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	"out.writeULong(" + str + ".length" + ");");

      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	"for(int " + index + " = 0; "+ index + " < " + str + 
        ".length; " + index + "++)");

      printIndent(indent + 2, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println("{");

      base_.genStubIn(indent + 4, str + "[" + index + "]");

      printIndent(indent + 2, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println("}");
    }

  void genStubOut(int indent, String str)
    {
      if(id_ == null)
	id_ = "Seq" + Generator.index_++;
      String index = id_ + "Ind";

      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(str + 
					  " = new " +
					  base_.toString() + 
					  "[in.readULong()];");
      
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	"for(int " + index + " = 0; "+ index + " < " + str + 
        ".length; " + index + "++)");

      printIndent(indent + 2, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println("{");

      base_.genStubOut(indent + 4, str + "[" + index + "]");

      printIndent(indent + 2, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println("}");
    }

  void genSkelIn(int indent, String str)
    {
      if(id_ == null)
	id_ = "Seq" + Generator.index_++;
      String index = id_ + "Ind";

      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(str + 
					  " = new " +
					  base_.toString() + 
					  "[in.readULong()];");
      
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	"for(int " + index + " = 0; "+ index + " < " + str + 
        ".length; " + index + "++)");

      printIndent(indent + 2, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("{");

      base_.genSkelIn(indent + 4, str + "[" + index + "]");

      printIndent(indent + 2, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("}");
    }

  void genSkelOut(int indent, String str)
    {
      if(id_ == null)
	id_ = "Seq" + Generator.index_++;
      String index = id_ + "Ind";

      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	"out.writeULong(" + str + ".length" + ");");

      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	"for(int " + index + " = 0; "+ index + " < " + str + 
        ".length; " + index + "++)");

      printIndent(indent + 2, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("{");

      base_.genSkelOut(indent + 4, str + "[" + index + "]");

      printIndent(indent + 2, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println("}");
    }

  void freezeContext()
    {
      base_.freezeContext();
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("SEQUENCE: " + id_);
      base_.print(indent + 2);
    }
}
