// for emacs only: -*- C++ -*-

// last update: 09/17/1997

package EDU.rutgers.CORBA.idl.ir;

public class SpecificationCell extends Cell
{
  public SpecificationCell(DefinitionCell definition,
			   SpecificationCell specification)
    {
      type_ = T_SPECIFICATION;
      definition_ = definition;
      specification_ = specification;
    }

  public void generate(int indent) throws java.io.IOException
    {
      definition_.generate(indent);
      if(specification_ != null) specification_.generate(indent);
    }

  // for debugging
  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("SPECIFICATION:");
      if(definition_ != null)
	definition_.print(indent + 2);
      else
	{
	  printIndent(indent + 2);
	  System.out.println("null");
	}      

      if(specification_ != null)
	specification_.print(indent + 2);
      else
	{
	  printIndent(indent + 2);
	  System.out.println("null");
	}      
    }

  // data members

  public DefinitionCell definition_;
  public SpecificationCell specification_;
}
