// for emacs only: -*- C++ -*-

// last update: 08/31/1997

package EDU.rutgers.CORBA.idl.ir;

public class StringCell extends ParamTypeSpecCell
{
  public StringCell(int size)
    {
      type_ = T_STRING;
      ival_ = size;
    }

  public int ival_; // size

  public void generate(int attr)
    {
      String type = ((attr == ParamDclCell.IN) ? "String" : "StringHolder");
      Generator.interfaceWriter_.print(type);
      Generator.staticStubWriter_.print(type);
      Generator.staticSkelWriter_.print(type);
    }

  public String toString()
    {
      return "String";
    }

  public String toString(int attr)
    {
      if(attr == ParamDclCell.IN)
	return "String";
      return "StringHolder";
    }

  public String initialValue()
    {
      return "null";
    }

  void genStubIn(int indent, String str)
    {
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	"out.writeString(" +
        str +
	");"
				);
    }

  void genStubOut(int indent, String str)
    {
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(
	str +
	" = in.readString();"
				);
    }

  void genSkelIn(int indent, String str)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	str +
        " = in.readString();");
    }

  void genSkelOut(int indent, String str)
    {
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(
	"out.writeString(" +
        str +
	");"
					  );
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("string: " + ival_);
    }
}
