// for emacs only: -*- C++ -*-

// last update: 01/13/1998

package EDU.rutgers.CORBA.idl.ir;

public class StructTypeCell extends ParamTypeSpecCell
{
  public String name_; // name of the struct
  public MemberList memberList_; // data members

  public StructTypeCell(String name, MemberList memberList)
    {
      type_ = T_STRUCT;
      name_ = name;
      memberList_ = memberList;
    }

  public void generate(int attr)
    {
      String type = toString(attr);
      Generator.interfaceWriter_.print(type);
      Generator.staticStubWriter_.print(type);
      Generator.staticSkelWriter_.print(type);
    }

  public String toString()
    {
      return name_;
    }

  public String toString(int attr)
    {
      return name_ + ((attr == ParamDclCell.IN) ? "": 
                                                             "Holder");
    }

  public String initialValue()
    {
      return "null";
    }

  void genStubIn(int indent, String str)
    {
      MemberList current;
      for(current = memberList_;
	  current != null;
	  current = current.next_)
	{
	  current.memberType_.genStubIn(indent, str + "." + current.id_);
	}
    }

  void genStubOut(int indent, String str)
    {
      MemberList current;
      printIndent(indent, Generator.staticStubWriter_);
      Generator.staticStubWriter_.println(str +  " = new " + name_ + "();");
      for(current = memberList_;
	  current != null;
	  current = current.next_)
	{
	  current.memberType_.genStubOut(indent, str + "." + current.id_);
	}
    }

  void genSkelIn(int indent, String str)
    {
      MemberList current;
      printIndent(indent, Generator.staticSkelWriter_);
      Generator.staticSkelWriter_.println(str +  " = new " + name_ + "();");
      for(current = memberList_;
	  current != null;
	  current = current.next_)
	{
	  current.memberType_.genSkelIn(indent, str + "." + current.id_);
	}
    }

  void genSkelOut(int indent, String str)
    {
      MemberList current;
      for(current = memberList_;
	  current != null;
	  current = current.next_)
	{
	  current.memberType_.genSkelOut(indent, str + "." + current.id_);
	}
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("STRUCT: " + name_);
    }
}
