// for emacs only: -*- C++ -*-

// last update: 11/19/1997

package EDU.rutgers.CORBA.idl.ir;

import java.util.Hashtable;

public class TypeDeclaratorCell extends TypeDclCell
{
  public TypeDeclaratorCell(ParamTypeSpecCell newType,
			    IdList dclList)
    {
      type_ = T_TYPE_DEF;
      newType_ = newType; // the constructed type
      dclList_ = dclList; // the names of the defined types
    }
  
  public void generate(int indent) throws java.io.IOException
    {
      IdList current = dclList_;
      Hashtable ht = Generator.symTab_;
      ParamTypeSpecCell type = newType_;

      type.freezeContext();

      // add all the defined types in the symbol table
      do
	{
	  String key = Generator.packTrack_.toString() + "." + current.id_;
	  ht.put(key, type);
	  current = current.next_;
	}
      while(current != null);

      if(newType_ instanceof SequenceCell)
	{
	  SequenceCell seq = (SequenceCell)newType_;
	  for(IdList id = dclList_; id != null; id = id.next_)
	    {
	      //
	      // holder
	      //
	      java.io.PrintWriter holder =
		new java.io.PrintWriter(
		  Generator.fileFactory_.create(id + "Holder.java"));
	      holder.println(
			 "package " + Generator.packTrack_.toString() +
			 ";\n\n");
	      holder.println("final public class " + id + "Holder");
	      holder.println("{");
	      holder.println("  public " + seq.base_.toString() + 
			     "[] value;");
	      holder.println("  public " + id + 
			     "Holder() {}");
	      holder.println("  public " + id + 
			     "Holder(" + seq.base_.toString() +
			     "[] initial) {");
	      holder.println("    value = initial;");
	      holder.println("  }");
	      holder.println("}");
	      holder.close();
	    }
	}
    }

  public void print(int indent)
    {
      printIndent(indent);
      System.out.println("TYPEDEF CELL: " + dclList_.toString(", "));
      if(newType_ != null)
	newType_.print(indent + 2);
    }

  // data members
  public ParamTypeSpecCell newType_;
  public IdList dclList_;
}
