/*
 * @(#)%Name% %Version% %Time%
 * 
 * Copyright (c) 1997 Rutgers University
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that (i) the above copyright notice and this permission notice
 * appear in all copies of the software and related documentation. (ii) 
 * the name of Rutgers University may not be used in any advertising
 * or publicity relating to the software without the specific, prior
 * written permission of Rutgers University.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL RUTGERS UNIVERSITY BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
 * THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE
 * OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * CopyrightVersion %Version%
 * @author		%Author%
 * @version		%Version%, %Time%
 * @since		ACT %Version%
 *
 */

package EDU.rutgers.CORBA.presentation;

/**
 * [CORBA 2.0 Specification 12-4]
 *
 * @since ACT 0.1
 */
public class CDRTransferSyntax
{
  public static CDRTransferSyntax cdrTS_ = new CDRTransferSyntax();

  private CDRTransferSyntax() {} 

  public int calAlignGap(int index, int alignment)
    {
//      int remainder = index % alignment;
      int remainder = index & (alignment - 1);
      if(remainder == 0)
	return 0;
      else
	return alignment - remainder;

      // the formula is:
      // (alignment - index % alignment) % alignment
      // but I couldn't transform it to contain only one
      // modulo operation - Cris
    }

  /* Weicong Wang's old method, replaced on 5/24/98 by Cris Francu
  public int calAlignGap(int index, int alignment)
    {
      if (alignment == 1) 
	{
	  return 0;
        }
      int remainder = alignment - (index % alignment);
      if (remainder == alignment)
	{
	  return 0;
	}
      return remainder;
    }
  */
}
