// for emacs: -*- C++ -*-

// last update: 05/29/98
// 03/12/98 added verbose mode

package EDU.rutgers.act.clntsrv.threadengine;

import EDU.rutgers.act.protocol.*;
import EDU.rutgers.util.Verbose;

/**
 * This class implements the main loop in method
 * "run".  During this loop the Acceptor uses
 * a ConnectionFactory object to create a
 * Connection object.  A Connection object
 * handles one socket.  The Acceptor simply
 * spawns new Connection objects every time
 * a client connects.
 * 
 */
public class Acceptor
{
  protected ConnectionFactory connectionFactory_;
  protected Server protocolServer_;

  public Acceptor(ConnectionFactory cf, Server ps)
    {
              if(Verbose.verbose)
		{
		  Verbose.print("Acceptor",
				"Acceptor",
				"creating the Acceptor");
		}
      connectionFactory_ = cf;
      protocolServer_ = ps;
    } 

  // public methods
  public void run() throws java.io.IOException
    {
      while(true)
	{
              if(Verbose.verbose)
		{
		  Verbose.print("Acceptor",
				"run",
				"calling ProtocolServer.accept()");
		}
	  Protocol protocol = protocolServer_.accept();
              if(Verbose.verbose)
		{
		  Verbose.print("Acceptor",
				"run",
				"creating a Connection");
		}
	  connectionFactory_.createConnection(protocol);
	}
    }
}
