// for emacs: -*- C++ -*-

// last update: 07/28/97

package EDU.rutgers.act.clntsrv.threadengine;

import EDU.rutgers.act.protocol.*;

/**********************************************
 * ConnectionFactory                          *
 **********************************************/
/**********************************************
 * This class creates a Connection object and
 * returns it. It is responsible with the
 * multi-threading policy (non-threaded, TpR,
 * TpS, PoT). For mono-threaded servers it
 * will return the same Connection object,
 * such that connections will be serialized.
 * For Thread-per-Session servers it will
 * create a new Connection every time a client
 * connects.  For Thread-per Request, no
 * difference.  For Pool-of-Threads it will
 * pre-spawn initially n threads, and every
 * time a client connects it will choose
 * the next available thread and then return
 * the Connection object running in that thread.
 **********************************************/
public interface ConnectionFactory { 
  // public methods
  void createConnection(Protocol protocol);
}
