// for emacs: -*- C++ -*-

// last update: 07/28/97

package EDU.rutgers.act.clntsrv.threadengine;

import EDU.rutgers.act.protocol.*;

/**********************************************
 * SEQRequestHandlerFactory                      *
 **********************************************/
/**********************************************
 * This class is used to implement both the
 * SEQuential policy and the ThreadPerConnection
 * policy.  If used in combination with
 * SEQConnectionFactory it yields in a sequential
 * policy.  If used in combination with 
 * TCPConnectionFactory it yields in a Thread
 * per connection policy.
 **********************************************/
public class SEQRequestHandlerFactory implements RequestHandlerFactory { 
  // contructors
  public SEQRequestHandlerFactory(Service service)
    {
      service_ = service;
    }
  

  // public methods
  public void createRequestHandler(Message request,
				   Sender serverSender)
    {
      RequestHandler requestHandler = 
	new RequestHandler(service_,
			   request,
			   serverSender);

      requestHandler.run();
    }
  

  // data members
  Service service_;
}
