// for emacs: -*- C++ -*-

// last update: 07/30/97
// 03/12/98 added verbose mode

package EDU.rutgers.act.clntsrv.threadengine;

import EDU.rutgers.act.protocol.*;
import EDU.rutgers.util.Verbose;

/**********************************************
 * TPCConnectionFactory                       *
 **********************************************/
/**********************************************
 * This class creates implements both the 
 * ThreadPerConnection policy and ThreadPerRequest
 * policy.  If used with SEQRequestHandlerFactory
 * it yields in a thread per connection
 * factory.  If used with TPRRequestHandlerFactory
 * it yields in a thread per request policy.
 **********************************************/
public class TPCConnectionFactory implements ConnectionFactory
{ 
  // constructors
  public TPCConnectionFactory(RequestHandlerFactory requestHandlerFactory)
    {
              if(Verbose.verbose)
		{
		  Verbose.print("TPCConnectionFactory",
				"TPCConnectionFactory",
				"created");
		}
      requestHandlerFactory_ = requestHandlerFactory;
    }

  // public methods
  public void createConnection(Protocol protocol)
    {
              if(Verbose.verbose)
		{
		  Verbose.print("TPCConnectionFactory",
				"createConnection",
				"creating a new Connection");
		}
      Connection connection = new Connection(requestHandlerFactory_, protocol);
              if(Verbose.verbose)
		{
		  Verbose.print("TPCConnectionFactory",
				"createConnection",
				"launching a new Connection");
		}
      new Thread(connection).start();
              if(Verbose.verbose)
		{
		  Verbose.print("TPCConnectionFactory",
				"createConnection",
				"launched");
		}
    }

  // data members
  RequestHandlerFactory requestHandlerFactory_;
}
