package EDU.rutgers.act.endpoint.mcast;

import java.io.*;
import java.net.*;

//import inria.net.rtp.*;
import inria.net.lrmp.*;

public class Lsocket
{
  private LrmpProfile lrmpprof;
  private M_InputStream m_input;
  private Lrmp lrmprtp;

  protected OutputStream output;
  protected InputStream input;
  protected InputStreamFactory masterinput;
  byte[] buffer;
  protected String version = "Lsocket1.0";
  public int len;

  public Lsocket()
    {
      lrmpprof = new LrmpProfile();
      lrmpprof.setQoS(lrmpprof.NoLoss,        /* reliability */
		      true,                   /* ordered */
		      lrmpprof.AdaptedThroughput);
      masterinput = new InputStreamFactory();
      lrmpprof.setEventHandler(masterinput);
      lrmpprof.sendWindowSize = 64;
      lrmpprof.rcvWindowSize = 48;
      lrmpprof.bandwidth = 16;         /* kilo bits/sec */
    }

  public Lsocket(LrmpProfile profile)
    {
      lrmpprof = profile;
    }

  public Lsocket(String addr, int port, int ttl)
    {
      this();
      try
	{
	  lrmprtp= new Lrmp(addr,port,ttl,lrmpprof);
	  lrmprtp.start();
	}
      catch(Exception e)
	{
	  System.out.println("@Lsocket.java: " + e);
	}
    }


  public Lsocket(InetAddress addr, int port, int ttl,LrmpProfile prof)
    {
      try
	{
	  lrmprtp= new Lrmp(addr,port,ttl,prof);
	  lrmprtp.start();
	}
      catch(Exception e)
	{
	  System.out.println("@Lsocket.java: " + e);
	}
    }

  public void multicast_create (InetAddress addr, int port, int ttl)
    {
      try
	{
	  if (lrmprtp == null)
	    {
	      lrmprtp = new Lrmp(addr, port,ttl,lrmpprof);
	      lrmprtp.start();
	    }	  
	}
      catch(Exception e)
	{
	  System.out.println("@Lsocket.java: " + e);
	}
    }

  public void multicast_create (String addr, int port, int ttl)
    {
      try
	{
	  if (lrmprtp == null)
	    {	      
	      lrmprtp = new Lrmp(addr, port,ttl,lrmpprof);
	      lrmprtp.start();
	    }	  
	}
      catch(Exception e)
	{
	  System.out.println("@Lsocket.java: " + e);
	}
    }

  public InputStream accept()
    {
      Queue q;
      q = masterinput.accept();
      M_InputStream m = new M_InputStream(q);
      return (InputStream) m;
    }

  public InputStream getInputStream()
    {
      return (InputStream) m_input;
    }

  public OutputStream getOutputStream()
    {
      M_OutputStream m = new M_OutputStream(lrmprtp);
      return (OutputStream) m;
    }

  public void close()
    {
      lrmprtp.stop();
      lrmprtp = null;
    }

  public static void main(String[] arg)
    {
      try
	{
	  Lsocket L = new Lsocket("224.1.3.4",5050,16);
	  OutputStream out = L.getOutputStream();
	  String msg="HELLO CHRIS";
	  ObjectOutputStream bos = new ObjectOutputStream(out);
	  bos.writeObject(msg);
	  bos.flush();
	  InputStream in=L.accept();
	  byte[] b = new byte[10];
	  BufferedInputStream bis = new BufferedInputStream(in);
	  bis.read(b,0,b.length);
	  String mesg = new String(b,0,b.length);
	  System.out.println("The Sent Message: "+mesg);
	  in.read(b,0,b.length);
	  mesg = new String(b,0,b.length);
	  System.out.println("The Second Sent Message is: "+mesg);
	  L.close();
	}
      catch (Exception e)
	{
	}
    }
}
