package EDU.rutgers.act.endpoint.mcast;

// import inria.net.rtp.*;
import inria.net.lrmp.*;

import java.io.*;
import java.util.*;

public class M_InputStream extends InputStream
{
  private LrmpPacket packet;
  private int offset, length;
  private Queue packet_queue;
  private Thread thread;

  public M_InputStream(Queue packet_queue_)
    {
      packet_queue= packet_queue_;
      packet = null;
      length = 0; // no bytes available in the beginning
    }

  public int read(byte b[])
    {
      return read(b, 0, b.length);
    }

  public int read(byte b[],int bufOffset,int bufLength)
    {
      while(length == 0)
	{
	  packet=(LrmpPacket)packet_queue.remove();
	  offset = packet.getOffset();
	  length = packet.getDataLength();
	}
    
      if(bufLength > length)
	bufLength = length;
    
      System.arraycopy(packet.getDataBuffer(),
		       offset,
		       b,
		       bufOffset,
		       bufLength);

      // update offset and length
      offset += bufLength;
      length -= bufLength;
      return bufLength;
    }

  public int read()
    {
      while(length == 0)
	{
	  packet=(LrmpPacket)packet_queue.remove();
	  offset = packet.getOffset();
	  length = packet.getDataLength();
	}
    
      // update offset and length
      length--;

      return packet.getDataBuffer()[offset++];
    }
}
