package EDU.rutgers.act.endpoint.mcast;

class Queue
{
  final static int DEFAULT_SIZE = 256;

  int size_, mask_, first_, last_;
  Semaphore notEmpty_, notFull_, reader_, writer_;
  
  protected Object[] evBuf_;

  public Queue()
    {
      setValues(256);
    }
  
  public Queue(int size)
    {
      if(size <= 0)
	{
	  size = DEFAULT_SIZE;
	}
      if(!twoPow(size))
	{
	  size = DEFAULT_SIZE;
	}

      setValues(size);
    }

  public boolean Isempty()
    {
      return notEmpty_.get() == 0;
    }

  public void insert(Object newItem)
    {
      notFull_.down();
      writer_.down();

      evBuf_[last_++] = newItem;
      last_ &= mask_;

      writer_.up();
      notEmpty_.up();
    }

  public Object remove()
    {
      Object retVal;

      notEmpty_.down();
      reader_.down();

      retVal = evBuf_[first_++];
      first_ &= mask_;

      reader_.up();
      notFull_.up();

      return retVal;
    }

  protected void setValues(int size)
    {
      evBuf_ = new Object[size_ = size];
      mask_ = size - 1;
      first_ = last_ = 0;

      notEmpty_ = new Semaphore(0);
      notFull_ = new Semaphore(size);
      reader_ = new Semaphore(1);
      writer_ = new Semaphore(1);
    }

  boolean twoPow(int n)
    {
      int i, ones;
      for(i = ones = 0; i < 32; i++, n >>= 1)
	{
	  ones += (n & 1);
	}
      return (ones == 1);
    }
}
