/*
 * @(#)%Name% %Version% %Time%
 * 
 * Copyright (c) 1998 Rutgers University
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that (i) the above copyright notice and this permission notice
 * appear in all copies of the software and related documentation. (ii) 
 * the name of Rutgers University may not be used in any advertising
 * or publicity relating to the software without the specific, prior
 * written permission of Rutgers University.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL RUTGERS UNIVERSITY BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
 * THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE
 * OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * CopyrightVersion %Version%
 * @author		%Author%
 * @version		%Version%, %Time%
 * @since		ACT %Version%
 *
 */

// last modification 01/20/98
// 03/12/98 added verbose mode

package EDU.rutgers.act.protocol.tcp;

import EDU.rutgers.util.Verbose;
import EDU.rutgers.act.protocol.*;

public class ClientCommunicator
{
    protected FSM fsm_;
    protected Message message_;

    ClientCommunicator(FSM fsm, Message message)
      {
        fsm_ = fsm;
        message_ = message;
      }

    Message receiveMessage() throws java.io.IOException
      {
        Message m = fsm_.run(message_);
    	        if(Verbose.verbose)
		  {
		    Verbose.print("ClientCommunicator",
				  "receiveMessage",
				  "received message: " + m);
		  }
	
        message_ = null;
        return m;
      }

    void setMessage(Message m)
      {
	message_ = m;
      }

    public void finalize() throws java.io.IOException
      {
	        if(Verbose.verbose)
		  {
		    Verbose.print("ClientCommunicator",
				  "finalize",
				  "going to GC " + this);
		  }
	
        fsm_.finalize();
        fsm_ = null;
      }
}
