/*
 * @(#)%Name% %Version% %Time%
 * 
 * Copyright (c) 1997 Rutgers University
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that (i) the above copyright notice and this permission notice
 * appear in all copies of the software and related documentation. (ii) 
 * the name of Rutgers University may not be used in any advertising
 * or publicity relating to the software without the specific, prior
 * written permission of Rutgers University.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL RUTGERS UNIVERSITY BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
 * THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE
 * OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * CopyrightVersion %Version%
 * @author		%Author%
 * @version		%Version%, %Time%
 * @since		ACT %Version%
 *
 */

// last modification: 01/23/98
// 03/29/98 added verbose mode

package EDU.rutgers.act.protocol.tcp;

import java.net.*;
import EDU.rutgers.util.Verbose;
import EDU.rutgers.act.protocol.*;

class FSMMapInfo
{
  public int id_;
  public Message message_;
  public SocketInfo socket_;
  public boolean waiting_;

  public FSMMapInfo(int id, Message message, SocketInfo socket, boolean waiting)
    {
              if(Verbose.verbose)
		{
		  Verbose.print("FSMMapInfo",
				"FSMMapInfo",
				"id=" + id +
				" msg=" + message +
				" sock=" + socket +
				" wait=" + waiting);
		}
      id_ = id;
      message_ = message;
      socket_ = socket;
      waiting_ = waiting;
    }

  public synchronized Message getMessage()
    {
              if(Verbose.verbose)
		{
		  Verbose.print("FSMMapInfo",
				"getMessage",
				"waiting=" + waiting_);
		}
      while(waiting_)
	{
	  try
	    {
                    if(Verbose.verbose)
		      {
			Verbose.print("FSMMapInfo",
				      "getMessage",
				      "going to wait");
		      }
	      wait();
	    }
	  catch(InterruptedException e)
	    {
                    if(Verbose.verbose)
		      {
			Verbose.print("FSMMapInfo",
				      "getMessage",
				      "interrupted, exception=" + e);
		      }
	    }
                    if(Verbose.verbose)
		      {
			Verbose.print("FSMMapInfo",
				      "getMessage",
				      "waiting=" + waiting_);
		      }
	}
                    if(Verbose.verbose)
		      {
			Verbose.print("FSMMapInfo",
				      "getMessage",
				      "returning message: " + message_);
		      }
      Message m = message_;
      message_ = null;
      waiting_ = true;
      return m;
    }

  public synchronized void setMessage(Message m)
    {
                    if(Verbose.verbose)
		      {
			Verbose.print("FSMMapInfo",
				      "setMessage",
				      "msg=" + m);
		      }
      message_ = m;
      waiting_ = false;
      notify();
    }
}
