package EDU.rutgers.cbus.presentation;

import java.util.EventObject;
import java.awt.event.FocusListener;
import java.awt.event.FocusEvent;
import java.awt.Component;

public class FocusAdaptor extends EventAdaptor implements FocusListener
{
  public FocusAdaptor(Component component)
    {
      super(component);
    }
  
 /*******************************************************
  * The FocusAdaptor is a source of FocusEvents.
  * Therefore implement all needed methods.
  *******************************************************/
  public synchronized void addFocusListener(FocusListener l)
    {
      eventListeners_.addElement(l);
    }
  
  public synchronized void removeFocusListener(FocusListener l)
    {
      eventListeners_.removeElement(l);
    }

  protected void invoke(Object target, EventObject event)
    {
      FocusEvent me = (FocusEvent)event;
      FocusListener ml = (FocusListener) target;

      switch(me.getID())
	{
	case FocusEvent.FOCUS_GAINED:
	  ml.focusGained(me);
	  break;
	case FocusEvent.FOCUS_LOST:
	  ml.focusLost(me);
	  break;
	default:
	  System.out.println("@FocusAdaptor.invoke(): illegal FocusEvent type");
	}
    }
 /*******************************************************
  * The FocusAdaptor is a listener of FocusEvents.
  * Therefore implement all needed methods.
  *******************************************************/
  public void focusGained(FocusEvent e)
    {
      this.processEvent(e);
    }
  
  public void focusLost(FocusEvent e)
    {
      this.processEvent(e);
    }
}
