package EDU.rutgers.cbus.presentation;

import java.util.EventObject;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseEvent;
import java.awt.Component;

public class MouseMotionAdaptor
  extends EventAdaptor
  implements MouseMotionListener
{
  public MouseMotionAdaptor(Component component)
    {
      super(component);
    }
  
 /*******************************************************
  * The MouseMotionAdaptor is a source of MouseEvents.
  * Therefore implement all needed methods.
  *******************************************************/
  public synchronized void addMouseMotionListener(MouseMotionListener l)
    {
      eventListeners_.addElement(l);
    }
  
  public synchronized void removeMouseMotionListener(MouseMotionListener l)
    {
      eventListeners_.removeElement(l);
    }

  protected void invoke(Object target, EventObject event)
    {
      MouseEvent me = (MouseEvent)event;
      MouseMotionListener ml = (MouseMotionListener) target;

      switch(me.getID())
	{
	case MouseEvent.MOUSE_MOVED :
	  ml.mouseMoved(me);
	  break;
	case MouseEvent.MOUSE_DRAGGED:
	  ml.mouseDragged(me);
	  break;
	default:
	  System.out.println("@MouseEventAdaptor.invoke(): illegal MouseEvent type");
	}
    }
 /*******************************************************
  * The MouseMotionAdaptor is a listener of MouseEvents.
  * Therefore implement all needed methods.
  *******************************************************/
  public void mouseDragged(MouseEvent e)
    {
      this.processEvent(e);
    }
  
  public void mouseMoved(MouseEvent e)
    {
      this.processEvent(e);
    }
}
