package EDU.rutgers.cbus.presentation;

import java.util.EventObject;
import java.awt.event.TextListener;
import java.awt.event.TextEvent;
import java.awt.Component;

public class TextAdaptor extends EventAdaptor implements TextListener
{
  public TextAdaptor(Component component)
    {
      super(component);
    }
  
 /*******************************************************
  * The TextAdaptor is a source of TextEvents.
  * Therefore implement all needed methods.
  *******************************************************/
  public synchronized void addTextListener(TextListener l)
    {
      eventListeners_.addElement(l);
    }
  
  public synchronized void removeTextListener(TextListener l)
    {
      eventListeners_.removeElement(l);
    }

  protected void invoke(Object target, EventObject event)
    {
      TextEvent te = (TextEvent)event;
      TextListener tl = (TextListener) target;

      tl.textValueChanged(te);
    }
 /*******************************************************
  * The TextAdaptor is a listener of TextEvents.
  * Therefore implement all needed methods.
  *******************************************************/
  public void textValueChanged(TextEvent e)
    {
      this.processEvent(e);
    }
}
