package EDU.rutgers.naming;

import java.util.Enumeration;
import java.util.Vector;

import EDU.rutgers.CORBA.clntsrv.PortableServer.ORB;
import ORG.omg.CosNaming.*;
// import CosNaming.NamingContextPackage.*;

public 
class 
_NamingContextImpl
	extends _NamingContextImplBase
	{
	private Vector contents = new Vector();

	public _NamingContextImpl()
		{
		ORB orb = ORB.init();
		orb.connect(this);
		}

	public void bind(NameComponent[] name, ORG.omg.CORBA.Object obj)
//		throws NotFound, CannotProceed, InvalidName, AlreadyBound
		{
		if ((name == null) || (name.length == 0))
		  {
		    System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: InvalidName exception");
		    // throw new InvalidName();
		  }
		

		if (name.length == 1)
			{
			Item item = find(name[0]);
			if (item != null)
			  {
			    System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: AlreadyBound exception");
			    // throw new AlreadyBound();
			  }
			

			contents.addElement(new Item(name[0], obj, BindingType.nobject));
			}
		else
			{
			ORG.omg.CORBA.Object context = resolve(lead(name));

			if (!(context instanceof NamingContext))
			  {
			    System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: NotFound exception");
			    // throw new NotFound(NotFoundReason.not_context, name);
			  }
			

			NameComponent[] nameEnd = new NameComponent[1];
			nameEnd[0] = name[name.length - 1];

			((NamingContext) context).bind(nameEnd, obj);
			}
		}

	public NamingContext new_context()
		{
		return new _NamingContextImpl();
		}

	public void rebind(NameComponent[] name, ORG.omg.CORBA.Object obj)
//		throws NotFound, CannotProceed, InvalidName
		{
		  if ((name == null) || (name.length == 0))
		    {
		      System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: InvalidName exception");
		      
		      // throw new InvalidName();
		    }
		  

		if (name.length == 1)
			{
			Item item = find(name[0]);
			if (item != null)
//				try {
					unbind(name);
//				}
//				catch (NotFound e1) { throw new CannotProceed(this, name); }
//				catch (InvalidName e2) { throw new CannotProceed(this, name); }

			contents.addElement(new Item(name[0], obj, BindingType.nobject));
			}
		else
			{
			ORG.omg.CORBA.Object nContext = resolve(lead(name));

			if (!(nContext instanceof NamingContext))
			  {
			    System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: NotFound exception");
			    
			    // throw new NotFound(NotFoundReason.not_context, name);
			  }
			

			NameComponent[] nameEnd = new NameComponent[1];
			nameEnd[0] = name[name.length - 1];

//			try {
				((NamingContext) nContext).bind(nameEnd, obj);
//			} catch (AlreadyBound e) { throw new CannotProceed(this, name); }
			}
		}

	public void unbind(NameComponent[] name)
//		throws NotFound, CannotProceed, InvalidName
		{
		  if ((name == null) || (name.length == 0))
		    {
		      System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: InvalidName exception");
		      
		      // throw new InvalidName();
		    }
		  
		if (name.length == 1)
			{
			Item item = find(name[0]);
			if (item == null)
			  {
			    System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: NotFound exception");
			    
			    // throw new NotFound(NotFoundReason.missing_node, name);
			  }
			

			if (!contents.removeElement(item))
			  {
			    System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: CannotProceed exception");
			    
			    // throw new CannotProceed(this, name);
			  }
			
			}
		else
			{
			ORG.omg.CORBA.Object context = resolve(lead(name));

			if (!(context instanceof NamingContext))
			  {
			    System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: NotFound exception");
			    
			    // throw new NotFound(NotFoundReason.not_context, name);
			  }
			

			NameComponent nameEnd[] = new NameComponent[1];
			nameEnd[0] = name[name.length - 1];

			((NamingContext) context).unbind(nameEnd);
			}
		}

	public void destroy()
//		throws NotEmpty
		{
		ORB orb = ORB.init();

		if (contents.size() > 0)
		  {
		    System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: NotEmpty exception");
		    
		    // throw new NotEmpty();
		  }
		

		orb.disconnect(this);
		}

	public NamingContext bind_new_context(NameComponent[] name)
//		throws NotFound, AlreadyBound, CannotProceed, InvalidName
		{
		_NamingContextImpl result = new _NamingContextImpl();

		bind_context(name, result);

		return result;
		}

	public void bind_context(NameComponent[] name, NamingContext context)
//		throws NotFound, AlreadyBound, CannotProceed, InvalidName
		{
		  if ((name == null) || (name.length == 0))
		    {
		      System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: InvalidName exception");
		      
		      // throw new InvalidName();
		    }
		  

		if (name.length == 1)
			{
			Item item = find(name[0]);
			if (item != null)
			  {
			    System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: AlreadyBound exception");
			    
			    // throw new AlreadyBound();
			  }
			

			contents.addElement(new Item(name[0], context,
					BindingType.ncontext));
			}
		else
			{
			ORG.omg.CORBA.Object nContext = resolve(lead(name));

			if (!(nContext instanceof NamingContext))
			  {
			    System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: NotFound exception");
			    
			    // throw new NotFound(NotFoundReason.not_context, name);
			  }
			

			NameComponent[] nameEnd = new NameComponent[1];
			nameEnd[0] = name[name.length - 1];

			((_NamingContextImpl) nContext).bind_context(nameEnd, context);
			}
		}

	public void rebind_context(NameComponent[] name, NamingContext context)
//		throws NotFound, CannotProceed, InvalidName
		{
		  if ((name == null) || (name.length == 0))
		    {
		      System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: InvalidName exception");
		      
		      // throw new InvalidName();
		    }
		  

		if (name.length == 1)
			{
			Item item = find(name[0]);
			if (item != null)
//				try {
					unbind(name);
//				}
//				catch (NotFound e1) { throw new CannotProceed(this, name); }
//				catch (InvalidName e2) { throw new CannotProceed(this, name); }

			contents.addElement(new Item(name[0], context,
					BindingType.ncontext));
			}
		else
			{
			ORG.omg.CORBA.Object nContext = resolve(lead(name));

			if (!(nContext instanceof NamingContext))
			  {
			    System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: NotFound exception");
			    
			    // throw new NotFound(NotFoundReason.not_context, name);
			  }
			

			NameComponent[] nameEnd = new NameComponent[1];
			nameEnd[0] = name[name.length - 1];

//			try {
				((_NamingContextImpl) nContext).bind_context(nameEnd, context);
//			} catch (AlreadyBound e) { throw new CannotProceed(this, name); }
			}
		}

	public ORG.omg.CORBA.Object resolve(NameComponent[] name)
//		throws NotFound, CannotProceed, InvalidName
		{
		  if ((name == null) || (name.length == 0))
		    {
		      System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: InvalidName exception");
		      
		      // throw new InvalidName();
		    }
		  

		Item item = find(name[0]);

		  if (item == null)
		    {
		      System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: NotFound exception");
		      
		      // throw new NotFound(NotFoundReason.missing_node, name);
		    }
		  

		if (name.length == 1)
			return (item.object);

		  if (item.binding_type != BindingType.ncontext)
		    {
		      System.out.println("EDU.rutgers.naming._NamingContextImpl.bind: NotFound exception");
		      
		      // throw new NotFound(NotFoundReason.not_context, name);
		    }
		  

		return (((NamingContext) item.object).resolve(tail(name)));
		}

	private Item find(NameComponent nameComponent)
		{
		Item result = null;

		for (Enumeration e = contents.elements(); e.hasMoreElements(); )
			{
			Item item = (Item) e.nextElement();

			if (item.equals(nameComponent))
				{
				result = item;
				break;
				}
			}

		return result;
		}

	private NameComponent[] tail(NameComponent[] name)
		{
		NameComponent[] result = new NameComponent[name.length - 1];

		for (int n = 0; n < name.length - 1; n++)
			result[n] = name[n + 1];

		return result;
		}

	private NameComponent[] lead(NameComponent[] name)
		{
		NameComponent[] result = new NameComponent[name.length - 1];

		for (int n = 0; n < name.length - 1; n++)
			result[n] = name[n];

		return result;
		}

/*
	public void list(int max,BindingListHolder list, BindingIteratorHolder iterator)
		{
		// !! No BindingIterator implementation, if n < contents.length
		// then just return n items.

		int count = contents.size();
		if (count > max)
			count = max;

		Binding[] result = new Binding[count];
		Enumeration e = contents.elements();

		for (int n = 0; n < count; n++)
			{
			Item item = (Item) e.nextElement();
			NameComponent[] name = new NameComponent[1];
			name[0] = item.name;

			result[n] = new Binding(name, item.binding_type);
			}

		list.value = result;
		}
*/		
      }
