/*
 * @(#)EDU/rutgers/.../Options.java 1.0 01/25/98
 * 
 *-------------------------------------------------
 * Options
 *-------------------------------------------------
 *
 * Copyright (c) 1997 Rutgers University
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that (i) the above copyright notice and this permission notice
 * appear in all copies of the software and related documentation, and
 * (ii) the name of Rutgers University may not be used in any advertising
 * or publicity relating to the software without the specific, prior
 * written permission of Rutgers University.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL RUTGERS UNIVERSITY BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
 * THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE
 * OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * CopyrightVersion 1.0
 * @author          Bogdan Dorohonceanu
 * @version         1.0, 01/25/98
 * @since           Options 1.0
 *
 */

package EDU.rutgers.util;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.StringTokenizer;

public class Options 
{
    // hashtable mapping between options and values
    private Hashtable opt2val_;
    
    // constructor
    public Options(String[] args, String options) throws Exception
    {
        opt2val_ = new Hashtable();
        StringTokenizer st = new StringTokenizer(options);
                
        // load options
        while (st.hasMoreElements())
        {
            String opt = "-" + st.nextToken();
            opt2val_.put(opt, "");   
        }
 
        // load values for options
        for (int i = 0; i < args.length; i ++)
        {
            st = new StringTokenizer(args[i]);
            if (st.hasMoreElements())
            {
                String opt = st.nextToken();
                i ++;
                if (opt2val_.containsKey(opt))
                {
                  st = new StringTokenizer(args[i]);
                  if (st.hasMoreElements()) 
                  {
                    String val = st.nextToken();
                    opt2val_.put(opt, val);
                  }
                }  
                else
                {
                    throw new Exception("Unknown option: " + opt);
                }
            }
        }
    }
    
    public String getValueOf(String opt)
    {
        return (String)opt2val_.get("-" + opt);
    }
/*    
    public static void main(String[] args)
    {
        String[] argvs = {"-AB", "1", "-BB", "2"};
        try 
        {
            GetOptions go = new GetOptions(argvs, "AB BB CB");    
            System.out.println(go.getValueOf("AB"));
            System.out.println(go.getValueOf("BB"));
            System.out.println(go.getValueOf("CB"));
        } 
        catch (Exception e)
        {
            System.err.println(e);
        }
    }
*/
}


