/*
 * @(#)%Name% %Version% %Time%
 * 
 * Copyright (c) 1997 Rutgers University
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that (i) the above copyright notice and this permission notice
 * appear in all copies of the software and related documentation. (ii) 
 * the name of Rutgers University may not be used in any advertising
 * or publicity relating to the software without the specific, prior
 * written permission of Rutgers University.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL RUTGERS UNIVERSITY BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
 * THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE
 * OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * CopyrightVersion %Version%
 * @author		%Author%
 * @version		%Version%, %Time%
 * @since		ACT %Version%
 *
 */

package ORG.omg.CORBA;

public final class TCKind
{
    public static final int _tk_null        = 0;
    public static final int _tk_void        = 1;
    public static final int _tk_short       = 2;
    public static final int _tk_long        = 3;
    public static final int _tk_ushort      = 4;
    public static final int _tk_ulong       = 5;
    public static final int _tk_float       = 6;
    public static final int _tk_double      = 7;
    public static final int _tk_boolean     = 8;
    public static final int _tk_char        = 9;
    public static final int _tk_octet       = 10;
    public static final int _tk_any         = 11;
    public static final int _tk_TypeCode    = 12;
    public static final int _tk_Principal   = 13;
    public static final int _tk_objref      = 14;
    public static final int _tk_struct      = 15;
    public static final int _tk_union       = 16;
    public static final int _tk_enum        = 17;
    public static final int _tk_string      = 18;
    public static final int _tk_sequence    = 19;
    public static final int _tk_array       = 20;
    public static final int _tk_alias       = 21;
    public static final int _tk_except      = 22;

    public static final TCKind tk_null =
        new TCKind(_tk_null);
    public static final TCKind tk_void = 
        new TCKind(_tk_void);
    public static final TCKind tk_short = 
        new TCKind(_tk_short);
    public static final TCKind tk_long = 
        new TCKind(_tk_long);
    public static final TCKind tk_ushort =
        new TCKind(_tk_ushort);
    public static final TCKind tk_ulong =
        new TCKind(_tk_ulong);
    public static final TCKind tk_float =
        new TCKind(_tk_float);
    public static final TCKind tk_double =
        new TCKind(_tk_double);
    public static final TCKind tk_boolean = 
        new TCKind(_tk_boolean);
    public static final TCKind tk_char =
        new TCKind(_tk_char);
    public static final TCKind tk_octet =
        new TCKind(_tk_octet);
    public static final TCKind tk_any = 
        new TCKind(_tk_any);
    public static final TCKind tk_TypeCode = 
        new TCKind(_tk_TypeCode);
    public static final TCKind tk_Principal = 
        new TCKind(_tk_Principal);
    public static final TCKind tk_objref = 
        new TCKind(_tk_objref);
    public static final TCKind tk_struct = 
        new TCKind(_tk_struct);
    public static final TCKind tk_union = 
        new TCKind(_tk_union);
    public static final TCKind tk_enum = 
        new TCKind(_tk_enum);
    public static final TCKind tk_string =
        new TCKind(_tk_string);
    public static final TCKind tk_sequence = 
        new TCKind(_tk_sequence);
    public static final TCKind tk_array = 
        new TCKind(_tk_array);
    public static final TCKind tk_alias = 
        new TCKind(_tk_alias);
    public static final TCKind tk_except = 
        new TCKind(_tk_except);

    private TCKind(int value) {        
        value = value; 
    }

    private int value;

    public int value() {
        return value; 
    }

    public static final TCKind type(int value) 
		throws BAD_PARAM {
        switch(value) {
            default:
				throw new BAD_PARAM("Enum out of range[0...22]: " + value);

            case _tk_null :
                return TCKind.tk_null;

            case _tk_void :
                return TCKind.tk_void;

            case _tk_short :
                return TCKind.tk_short;

            case _tk_long :
                return TCKind.tk_long;

            case _tk_ushort :
                return TCKind.tk_ushort;

            case _tk_ulong :
                return TCKind.tk_ulong;

            case _tk_float :
                return TCKind.tk_float;

            case _tk_double :
                return TCKind.tk_double;

            case _tk_boolean :
                return TCKind.tk_boolean;

            case _tk_char :
                return TCKind.tk_char;

            case _tk_octet :
                return TCKind.tk_octet;

            case _tk_any :
                return TCKind.tk_any;

            case _tk_TypeCode :
                return TCKind.tk_TypeCode;

            case _tk_Principal :
                return TCKind.tk_Principal;

            case _tk_objref :
                return TCKind.tk_objref;

            case _tk_struct :
                return TCKind.tk_struct;

            case _tk_union :
                return TCKind.tk_union;

            case _tk_enum :
                return TCKind.tk_enum;

            case _tk_string :
                return TCKind.tk_string;

            case _tk_sequence :
                return TCKind.tk_sequence;

            case _tk_array :
                return TCKind.tk_array;

            case _tk_alias :
                return TCKind.tk_alias;

            case _tk_except :
                return TCKind.tk_except;
        }
    }

	public String toString() {
        String[] types = {"tk_null", "tk_void", "tk_short", "tk_long", 
                         "tk_ushort", "tk_ulong", "tk_float", "tk_double",
                         "tk_boolean", "tk_char", "tk_octet", "tk_any",
                         "tk_TypeCode", "tk_Principal", "tk_objref", "tk_struct",
                         "tk_union", "tk_enum", "tk_string", "tk_sequence", 
                         "tk_array", "tk_alias", "tk_except",};
		return types[value];
	}
}
