// for emacs only: -*- C++ -*-

// last modified 12/18/97

package examples.ACTMUD;

import java.io.*;         // file input/output
import ORG.omg.CORBA.*;   // holder classes

import EDU.rutgers.CORBA.clntsrv.PortableServer.*; // ORB, POA, etc
import EDU.rutgers.CORBA.clntsrv.PortableServer.POAPackage.*; // exceptions

import examples.ACTMUD.generated.*; // interfaces, helpers, holders

class Client
{
  // file where the stringified IOR of the server can be found
  static final String FILE_NAME = "ior.txt";

  public static void main(String[] args) throws 
    IOException,
    ObjectNotActive,
    WrongPolicy
    {
      // initialize the ORB
      ORB orb = ORB.init(args, null);

      // initialize POA
      POA poa = orb.POA_init();

      // get the stringified IOR of the server to create the server stub
      byte[] bytes = new byte[1000];

      // open the file FILE_NAME
      FileInputStream file = new FileInputStream(FILE_NAME);

      // read the stringified IOR
      int length = file.read(bytes);

      // close the file
      file.close();

      // convert the byte array into a string
      String srvStrIOR = new String(bytes, 0, length);

      // get the server object reference
      ORG.omg.CORBA.Object reference = orb.string_to_object(srvStrIOR);

      // cast from a generic Object to a specific ACTMUDSrv
      ACTMUDSrv srvRef = ACTMUDSrvHelper.narrow(reference);
      
      // create implementation of client object
      _ACTMUDClntImpl clnt = new _ACTMUDClntImpl();

      // register implementation (publish the client)
      byte[] objectId = poa.activate_object(clnt);

      // activate the client
      clnt.launch(srvRef);

      // exit brutally
      System.exit(0);
    }
}
