// for emacs only: -*- C++ -*-

// last modified 12/18/97

package examples.ACTMUD;

import java.io.*;         // file input/output
import ORG.omg.CORBA.*;   // holder classes

import EDU.rutgers.CORBA.clntsrv.PortableServer.*; // ORB, POA, etc
import EDU.rutgers.CORBA.clntsrv.PortableServer.POAPackage.*; // exceptions

class Server
{
  static final String FILE_NAME = "ior.txt";

  public static void main(String[] args) throws 
    IOException,
    ObjectNotActive,
    WrongPolicy
    {
      // initialize the ORB
      ORB orb = ORB.init(args, null);

      POA poa = orb.POA_init();

      // create implementation
      _ACTMUDSrvImpl srv = new _ACTMUDSrvImpl();

      // register implementation
      byte[] objectId = poa.activate_object(srv);

      // create the stringified object reference for the server object (myself)
      String srvStrIOR = orb.object_to_string(srv);
      
      // write it to a file
      FileOutputStream file = new FileOutputStream(FILE_NAME);
      file.write(srvStrIOR.getBytes());
      file.close();

      System.out.println("Created stringified IOR for this object:");
      System.out.println(srvStrIOR);
    }
}
