// for emacs only: -*- C++ -*-

// last modified 12/23/97

package examples.InterORB.JIDLORB;

import java.io.*;         // file input/output
import org.omg.CORBA.ORB;

import examples.InterORB.JIDL.*; // interfaces, helpers, holders

class Client
{
  // file where the stringified IOR of the server can be found
  static final String FILE_NAME = "ior.txt";

  public static void main(String[] args) throws IOException, FileNotFoundException
    {
      // one argument please!
      if(args.length != 1)
	{
	  System.out.println("usage: java Client <int number>");
	  throw new IOException("Invalid arguments");
	}

      // initialize the ORB
      ORB orb = ORB.init(new String[0], null);

      // the main loop, no multi-threading please
      // orb.run();

      // get the stringified IOR of the server to create the server stub
      byte[] bytes = new byte[1000];

      // open the file FILE_NAME
      FileInputStream file = new FileInputStream(FILE_NAME);

      // read the stringified IOR
      int length = file.read(bytes);

      // close the file
      file.close();

      // convert the byte array into a string
      String srvStrIOR = new String(bytes, 0, length);

      // get the server object reference
      org.omg.CORBA.Object reference = orb.string_to_object(srvStrIOR);

      // cast from a generic Object to a specific TestObject
      TestObject srvRef = TestObjectHelper.narrow(reference);
      
      // call the 'print' method
      srvRef.print(Integer.parseInt(args[0]));
    }
}
