// for emacs only: -*- C++ -*-

// last modified 12/18/97

package examples.InterORB.JIDLORB;

import java.io.*;         // file input/output
import org.omg.CORBA.ORB;
import org.omg.CORBA.portable.Skeleton;

class Server
{
  static final String FILE_NAME = "ior.txt";

  public static void main(String[] args) throws 
    IOException
    {
      // usage, only one argument, please, port number to listen to
      if(args.length != 1)
	{
	  System.out.println("usage: java Server -ORBInitialPort <port>");
	  throw new IOException("Invalid arguments");
	}

      // initialize the ORB
      ORB orb = ORB.init((String[])null, null);

      // create implementation
      _TestObjectImpl srv = new _TestObjectImpl();

      // register implementation
      orb.connect(srv);

      // create the object reference for this server object (myself)
      // org.omg.CORBA.Object srvRef = poa.id_to_reference(objectId);
      String srvStrIOR = orb.object_to_string((org.omg.CORBA.Object)srv);
      
      // write it to a file
      FileOutputStream file = new FileOutputStream(FILE_NAME);
      file.write(srvStrIOR.getBytes());
      file.close();

      System.out.println("Created stringified IOR for this object:");
      System.out.println(srvStrIOR);

      // the main loop
      // wait for invocations from clients
      try
	{
	  java.lang.Object sync = new java.lang.Object();
	  synchronized (sync) {
	    sync.wait();
	  }
	}
      catch (Exception ex) {
	System.err.println("ERROR: " + ex);
	ex.printStackTrace(System.out);
      }
    }
}
