// for emacs only: -*- C++ -*-

// last modification 12/15/97

package examples.TSTP;

import java.io.*;
import EDU.rutgers.act.endpoint.Endpoint;
import EDU.rutgers.act.protocol.*;
import EDU.rutgers.CORBA.presentation.*;
import examples.TSTP.actions.*;
import examples.TSTP.messages.*;

class Client
{
  public static void main(String args[]) throws java.io.IOException
    {
      if(args.length != 2)
	{
	  System.out.println("usage: Client <hostname> <portnumber>");
	  throw new IOException("Invalid arguments");
	}

      FSMDataFactory tstpClntFactory =
	(FSMDataFactory)new TSTPClientDataFactory();
      MessageFactory msgFactory = 
	(MessageFactory)new TSTPMessageFactory();

      Sender clientSender = new ClientSender(tstpClntFactory,
					     msgFactory,
					     new CDRTransferSyntaxFactory());

      Endpoint dest = new Endpoint(args[0],
				   Integer.parseInt(args[1]));

      String[] str_ptr = new String[1];
      

      int operation;
      char command = readCommand(str_ptr);
      while(command != 'q')
	{
	  switch(command)
	    {
	    case 'e':
	      operation = TSTPMessage.ECHO;
	      break;

	    case 'r':
	      operation = TSTPMessage.REVERT;
	      break;
	  
	    case 'u':
	      operation = TSTPMessage.TOUPPER;
	      break;
	  
	    case 'l':
	      operation = TSTPMessage.TOLOWER;
	      break;
	  
	    default:
	      System.out.println("Invalid operation - replacing it with eCHO");
	      operation = TSTPMessage.ECHO;
	    }
      
	  TSTPMessage msg = new TSTPMessage(TSTPMessage.Request,
					    operation,
					    str_ptr[0],
					    dest);
	  System.out.println("Sending <"+msg.getString()+">");

	  clientSender.sendMessage(msg);
	  Receiver clientReceiver = new ClientReceiver(msg.getTransactionId());
	  TSTPMessage answer = (TSTPMessage)clientReceiver.receiveMessage();

	  System.out.println("Answer is <"+answer.getString()+">");

	  command = readCommand(str_ptr);
	}
    }

  static char readCommand(String[] str_ptr) throws IOException
    {
      byte[] line1 = new byte[256];
      byte[] line2 = new byte[256];

      System.out.print("string to be processed: ");
      int len = System.in.read(line1) - 1;
      str_ptr[0] = new String(line1, 0, len);
      System.out.print("command (eCHO, rEVERT, TOuPPER, TOlOWER): ");
      System.in.read(line2);
      return (char)line2[0];
    }
}
