// for emacs only: -*- C++ -*-

// last update: 11/20/97

import java.io.*;         // file input/output
import ORG.omg.CORBA.*;   // holder classes
import EDU.rutgers.CORBA.clntsrv.PortableServer.*; // ORB, POA, etc
import Testing.*;         // the idl interfaces

public class Client
{
  final static String FILE_NAME = "ior.txt";

  public static void main(String[] args) throws
    IOException, FileNotFoundException
    {
      if(args.length == 0)
	{
	  System.out.println("usage: java Client <array size>");
	  System.exit(0);
	}

      int size = Integer.parseInt(args[0]);
      String newArgs[] = new String[args.length - 1];
      for(int i = 1; i < args.length; i++)
	{
	  newArgs[i - 1] = args[i];
	}

      // initialize the ORB
      ORB orb = ORB.init(newArgs, null);

      // read the stringified IOR
      byte[] bytes = new byte[1000];
      FileInputStream file = new FileInputStream(FILE_NAME);
      int length = file.read(bytes);
      file.close();
      String stringifiedIOR = new String(bytes, 0, length);

      // creating the object reference
      ORG.omg.CORBA.Object reference = orb.string_to_object(stringifiedIOR);
      ArrayProcessor stub = ArrayProcessorHelper.narrow(reference);
      
      // prepare array to be reverted
      int[] a = new int[size];
      for(int i = 0; i < a.length; i++)
	a[i] = i;

      ArrayHolder arg = new ArrayHolder(a);

      boolean result;
      long startTime = System.currentTimeMillis();
      // making the remote calls
      for(int i = 0; i < 1000; i++)
	result = stub.revert(arg);
      startTime -= System.currentTimeMillis();
      
      System.out.println("Average time for a call involving sending an array of " + size +
			 " integers roundtrip is: \n" +
			 (-startTime / 1000.0) + " milliseconds"
			 );
      System.exit(0);
    }
}
