// for emacs only: -*- C++ -*-

// last update: 09/23/97

import java.io.*;         // file input/output
import ORG.omg.CORBA.*;   // holder classes
import Testing.*;         // the idl interfaces

import EDU.rutgers.CORBA.clntsrv.PortableServer.*; // ORB, POA, etc
import EDU.rutgers.CORBA.clntsrv.PortableServer.POAPackage.*; // exceptions

class Server
{
  static final String FILE_NAME = "ior.txt";

  public static void main(String[] args) throws 
    IOException,
    ObjectNotActive,
    WrongPolicy
    {
      // initialize the ORB
      ORB orb = ORB.init(args, null);

      POA poa = orb.POA_init();

      // create implementation
      _ArrayProcessorImpl servant = new _ArrayProcessorImpl();

      // register implementation
      orb.connect(servant);

      // get the object reference for this servant
      String stringifiedIOR = orb.object_to_string(servant);
      
      // write it to a file
      FileOutputStream file = new FileOutputStream(FILE_NAME);
      file.write(stringifiedIOR.getBytes());
      file.close();

      System.out.println("Created stringified IOR for this object:");
      System.out.println(stringifiedIOR);
    }
}
