package examples.loader;

import java.awt.Frame;
import java.awt.Component;
import java.awt.FlowLayout;

import EDU.rutgers.cbus.presentation.SimpleConnector;
import EDU.rutgers.cbus.clntsrv.Communicator;
import EDU.rutgers.cbus.tools.UnawareLinker;

class Loader extends Frame
{
  protected final static int TFX = 100, TFY = 30;
  protected final static int BX = 50, BY = 30;
  protected final static int SP = 5;

  public static void main(String[] args)
    {
      Frame win = new Frame("Application Linker");
      win.setLayout(new FlowLayout());
      win.setSize(600, 800);

      // multicast communicator (true = mcast)
      Communicator comm = new Communicator(true);
      SimpleConnector sc = new SimpleConnector(comm);
      win.add(sc);
      UnawareLinker linker = new UnawareLinker(comm);

      Object o = null;
      for(int i = 0; i < args.length; i++)
	{
	  try
	    {
	      Class c = Class.forName(args[i]);
	      o = c.newInstance();
	    }
	  catch(Exception e)
	    {
	      System.out.println("error: " + e);
	    }
	  win.add((Component)o);
	  linker.link((Component)o);
	}

      win.setVisible(true);
    }
}
